<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<title>magpar: init/magset.c Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<link href="doxygen.css" rel="stylesheet" type="text/css"/>
</head>
<body>
<!-- Generated by Doxygen 1.6.3 -->
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
      <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Data&nbsp;Structures</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div class="tabs">
    <ul>
      <li><a href="files.html"><span>File&nbsp;List</span></a></li>
      <li><a href="globals.html"><span>Globals</span></a></li>
    </ul>
  </div>
  <div class="navpath"><a class="el" href="dir_f813120d4be15aaed9e35a3518d2a85e.html">init</a>
  </div>
</div>
<div class="contents">
<h1>magset.c</h1><a href="magset_8c.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">    This file is part of magpar.</span>
<a name="l00003"></a>00003 <span class="comment"></span>
<a name="l00004"></a>00004 <span class="comment">    Copyright (C) 2002-2010 Werner Scholz</span>
<a name="l00005"></a>00005 <span class="comment"></span>
<a name="l00006"></a>00006 <span class="comment">    www:   http://www.magpar.net/</span>
<a name="l00007"></a>00007 <span class="comment">    email: magpar(at)magpar.net</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">    magpar is free software; you can redistribute it and/or modify</span>
<a name="l00010"></a>00010 <span class="comment">    it under the terms of the GNU General Public License as published by</span>
<a name="l00011"></a>00011 <span class="comment">    the Free Software Foundation; either version 2 of the License, or</span>
<a name="l00012"></a>00012 <span class="comment">    (at your option) any later version.</span>
<a name="l00013"></a>00013 <span class="comment"></span>
<a name="l00014"></a>00014 <span class="comment">    magpar is distributed in the hope that it will be useful,</span>
<a name="l00015"></a>00015 <span class="comment">    but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00016"></a>00016 <span class="comment">    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the</span>
<a name="l00017"></a>00017 <span class="comment">    GNU General Public License for more details.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">    You should have received a copy of the GNU General Public License</span>
<a name="l00020"></a>00020 <span class="comment">    along with magpar; if not, write to the Free Software</span>
<a name="l00021"></a>00021 <span class="comment">    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00022"></a>00022 <span class="comment">*/</span>
<a name="l00023"></a>00023 
<a name="l00024"></a>00024 <span class="keyword">static</span> <span class="keywordtype">char</span> <span class="keyword">const</span> Id[] = <span class="stringliteral">&quot;$Id: magset.c 2964 2010-02-05 19:31:03Z scholz $\n\n&quot;</span>;
<a name="l00025"></a>00025 <span class="keyword">static</span> <span class="keywordtype">char</span> <span class="keyword">const</span> Td[] = <span class="stringliteral">&quot;$Today: &quot;</span> __FILE__ <span class="stringliteral">&quot;  &quot;</span> __DATE__ <span class="stringliteral">&quot;  &quot;</span>  __TIME__  <span class="stringliteral">&quot; $\n\n&quot;</span>;
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;<a class="code" href="init_8h.html">init.h</a>&quot;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="magpario_8h.html">io/magpario.h</a>&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="util_8h.html">util/util.h</a>&quot;</span>
<a name="l00030"></a>00030 
<a name="l00031"></a><a class="code" href="magset_8c.html#a8fd02adfde9e3d9ac120c87dee020678">00031</a> <span class="keywordtype">int</span> <a class="code" href="init_8h.html#a8fd02adfde9e3d9ac120c87dee020678">MagSet</a>(<span class="keywordtype">int</span> pid,<span class="keywordtype">int</span> init_mag,PetscReal init_magparm,<a class="code" href="structGridData.html">GridData</a> *gdata)
<a name="l00032"></a>00032 {
<a name="l00033"></a>00033   <a class="code" href="griddata_8h.html#a3d9da926137619fd02adb245a08536c7">MagparFunctionLogBegin</a>;
<a name="l00034"></a>00034 
<a name="l00035"></a>00035   <span class="keywordtype">int</span> rank,size;
<a name="l00036"></a>00036   ierr = MPI_Comm_size(PETSC_COMM_WORLD,&amp;size);CHKERRQ(ierr);
<a name="l00037"></a>00037   ierr = MPI_Comm_rank(PETSC_COMM_WORLD,&amp;rank);CHKERRQ(ierr);
<a name="l00038"></a>00038 
<a name="l00039"></a>00039 
<a name="l00040"></a>00040   PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;pid:          %i\n&quot;</span>,pid+1);
<a name="l00041"></a>00041   PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;init_mag:     %i\n&quot;</span>,init_mag);
<a name="l00042"></a>00042   PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;init_magparm: %g\n&quot;</span>,init_magparm);
<a name="l00043"></a>00043 
<a name="l00044"></a>00044   <span class="keywordflow">if</span> (init_mag==0) {
<a name="l00045"></a>00045     <span class="keywordtype">char</span> fmesh[256];
<a name="l00046"></a>00046     PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;inp file to be read: %s.%04d.inp\n&quot;</span>,gdata-&gt;<a class="code" href="structGridData.html#a2fba16fa768b0451df8fd12ed00a6c6b">simname</a>,gdata-&gt;<a class="code" href="structGridData.html#a4cc9b420611ac5eed22ee3bb2533fde4">inp</a>);
<a name="l00047"></a>00047     ierr = PetscSNPrintf(fmesh,255,<span class="stringliteral">&quot;%s.%04d.inp&quot;</span>,gdata-&gt;<a class="code" href="structGridData.html#a2fba16fa768b0451df8fd12ed00a6c6b">simname</a>,gdata-&gt;<a class="code" href="structGridData.html#a4cc9b420611ac5eed22ee3bb2533fde4">inp</a>);CHKERRQ(ierr);
<a name="l00048"></a>00048     gdata-&gt;<a class="code" href="structGridData.html#a4cc9b420611ac5eed22ee3bb2533fde4">inp</a>++;
<a name="l00049"></a>00049 
<a name="l00050"></a>00050     ierr = <a class="code" href="magpario_8h.html#ac48e244b5ec28e4a0d8a7ce8596bbe76">ReadINP</a>(gdata,fmesh,gdata-&gt;<a class="code" href="structGridData.html#aa8ed194b67f1446b9c299028c1ed0692">M</a>,1);CHKERRQ(ierr);
<a name="l00051"></a>00051     <a class="code" href="griddata_8h.html#a8491466d8534a33d7163f5ea747e8210">MagparFunctionLogReturn</a>(0);
<a name="l00052"></a>00052   }
<a name="l00053"></a>00053   <span class="keywordflow">else</span> <span class="keywordflow">if</span> (PetscAbsInt(init_mag)==14) {
<a name="l00054"></a>00054 <span class="preprocessor">#ifdef PYTHON</span>
<a name="l00055"></a>00055 <span class="preprocessor"></span>    <span class="keywordflow">if</span> (!rank) {
<a name="l00056"></a>00056       <span class="comment">/* Python stuff */</span>
<a name="l00057"></a>00057 
<a name="l00058"></a>00058       <span class="keywordflow">if</span>(!gdata-&gt;pModule) {
<a name="l00059"></a>00059         SETERRQ1(PETSC_ERR_ARG_CORRUPT,<span class="stringliteral">&quot;Cannot execute Python function. Module %s has not been imported!\n&quot;</span>,MAGPARSTDPYTHONMOD);
<a name="l00060"></a>00060       }
<a name="l00061"></a>00061 
<a name="l00062"></a>00062 <span class="preprocessor">#define INITMAG &quot;initmag&quot;</span>
<a name="l00063"></a>00063 <span class="preprocessor"></span>      PyObject *pFunc;
<a name="l00064"></a>00064       pFunc=PyObject_GetAttrString(gdata-&gt;pModule,INITMAG);  <span class="comment">/* new reference */</span>
<a name="l00065"></a>00065       <span class="keywordflow">if</span>(!pFunc) {
<a name="l00066"></a>00066         SETERRQ1(PETSC_ERR_ARG_CORRUPT,<span class="stringliteral">&quot;Cannot find Python function %s!\n&quot;</span>,INITMAG);
<a name="l00067"></a>00067       }
<a name="l00068"></a>00068       <span class="keywordflow">if</span> (!PyCallable_Check(pFunc)) {
<a name="l00069"></a>00069         SETERRQ1(PETSC_ERR_ARG_CORRUPT,<span class="stringliteral">&quot;Python object %s is not callable (not a function)!\n&quot;</span>,INITMAG);
<a name="l00070"></a>00070       }
<a name="l00071"></a>00071 
<a name="l00072"></a>00072       <span class="comment">/* Arguments for the module */</span>
<a name="l00073"></a>00073       PyObject *pTuple;
<a name="l00074"></a>00074       pTuple = PyTuple_New(<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>); <span class="comment">/* new reference */</span>
<a name="l00075"></a>00075 
<a name="l00076"></a>00076       PyObject *pVal=PETSC_NULL;
<a name="l00077"></a>00077 
<a name="l00078"></a>00078       <span class="comment">/* this example sets the external field in a certain area to a</span>
<a name="l00079"></a>00079 <span class="comment">         non-zero value and everywhere else to zero</span>
<a name="l00080"></a>00080 <span class="comment">      */</span>
<a name="l00081"></a>00081 
<a name="l00082"></a>00082       <span class="comment">/* make the magnetization vector accessible */</span>
<a name="l00083"></a>00083       PetscReal *ta_M;
<a name="l00084"></a>00084       ierr = VecGetArray(gdata-&gt;<a class="code" href="structGridData.html#aa8ed194b67f1446b9c299028c1ed0692">M</a>,&amp;ta_M);CHKERRQ(ierr);
<a name="l00085"></a>00085 
<a name="l00086"></a>00086       <span class="comment">/* loop over all nodes */</span>
<a name="l00087"></a>00087       <span class="keywordflow">for</span> (<span class="keywordtype">int</span> j=0; j&lt;gdata-&gt;<a class="code" href="structGridData.html#a170b7b2a45022cc3d4aaee232844e50c">n_vert</a>; j++) {
<a name="l00088"></a>00088         PetscReal x,y,z;
<a name="l00089"></a>00089         x=gdata-&gt;<a class="code" href="structGridData.html#a1adbd5611aad877423d82c0ae9aae5ad">vertxyz</a>[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*j+0];
<a name="l00090"></a>00090         y=gdata-&gt;<a class="code" href="structGridData.html#a1adbd5611aad877423d82c0ae9aae5ad">vertxyz</a>[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*j+1];
<a name="l00091"></a>00091         z=gdata-&gt;<a class="code" href="structGridData.html#a1adbd5611aad877423d82c0ae9aae5ad">vertxyz</a>[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*j+2];
<a name="l00092"></a>00092 
<a name="l00093"></a>00093         PyTuple_SetItem(pTuple,0,PyFloat_FromDouble(x)); <span class="comment">/* The tuple steals the reference */</span>
<a name="l00094"></a>00094         PyTuple_SetItem(pTuple,1,PyFloat_FromDouble(y));
<a name="l00095"></a>00095         PyTuple_SetItem(pTuple,2,PyFloat_FromDouble(z));
<a name="l00096"></a>00096 
<a name="l00097"></a>00097         <span class="comment">/* Call the Python function */</span>
<a name="l00098"></a>00098         pVal = PyObject_CallObject(pFunc,pTuple);  <span class="comment">/* new reference */</span>
<a name="l00099"></a>00099 
<a name="l00100"></a>00100         <span class="comment">/* set magnetization */</span>
<a name="l00101"></a>00101         <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>; i++) {
<a name="l00102"></a>00102           ta_M[ND*j+i]=PyFloat_AsDouble(PyTuple_GetItem(pVal,i));
<a name="l00103"></a>00103         }
<a name="l00104"></a>00104       }
<a name="l00105"></a>00105 
<a name="l00106"></a>00106       ierr = VecRestoreArray(gdata-&gt;<a class="code" href="structGridData.html#aa8ed194b67f1446b9c299028c1ed0692">M</a>,&amp;ta_M);CHKERRQ(ierr);
<a name="l00107"></a>00107 
<a name="l00108"></a>00108       <span class="comment">/* decrement references */</span>
<a name="l00109"></a>00109       Py_DECREF(pFunc);
<a name="l00110"></a>00110       Py_DECREF(pTuple);
<a name="l00111"></a>00111       Py_DECREF(pVal);
<a name="l00112"></a>00112     }
<a name="l00113"></a>00113 <span class="preprocessor">#else</span>
<a name="l00114"></a>00114 <span class="preprocessor"></span>    SETERRQ(PETSC_ERR_ARG_CORRUPT,<span class="stringliteral">&quot;magpar not linked with Python interpreter. Cannot execute Python scripts!\n&quot;</span>);
<a name="l00115"></a>00115 <span class="preprocessor">#endif</span>
<a name="l00116"></a>00116 <span class="preprocessor"></span>  }
<a name="l00117"></a>00117 
<a name="l00118"></a>00118   <span class="keywordflow">if</span> (rank) {
<a name="l00119"></a>00119     VecAssemblyBegin(gdata-&gt;<a class="code" href="structGridData.html#aa8ed194b67f1446b9c299028c1ed0692">M</a>);
<a name="l00120"></a>00120     VecAssemblyEnd(gdata-&gt;<a class="code" href="structGridData.html#aa8ed194b67f1446b9c299028c1ed0692">M</a>);
<a name="l00121"></a>00121 
<a name="l00122"></a>00122     <span class="comment">/* rescale magnetization (required by init_mag==5) */</span>
<a name="l00123"></a>00123     <a class="code" href="renormvec_8c.html#abba3d002260d6e3e062ac69a80300aa4">RenormVec</a>(gdata-&gt;<a class="code" href="structGridData.html#aa8ed194b67f1446b9c299028c1ed0692">M</a>,1.0,0.0,<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>);
<a name="l00124"></a>00124 
<a name="l00125"></a>00125     <a class="code" href="griddata_8h.html#a8491466d8534a33d7163f5ea747e8210">MagparFunctionLogReturn</a>(0);
<a name="l00126"></a>00126   }
<a name="l00127"></a>00127   <span class="keywordflow">else</span> {
<a name="l00128"></a>00128     PetscRandom rctx;
<a name="l00129"></a>00129     ierr = PetscRandomCreate(PETSC_COMM_SELF,&amp;rctx);CHKERRQ(ierr);
<a name="l00130"></a>00130     ierr = PetscRandomSetFromOptions(rctx);CHKERRQ(ierr);
<a name="l00131"></a>00131     <span class="comment">/* assign property ids to vertices */</span>
<a name="l00132"></a>00132     ierr = <a class="code" href="init_8h.html#a031e1284b34dfcb64f029f9bd16545ce">VertProp</a>(gdata);CHKERRQ(ierr);
<a name="l00133"></a>00133 
<a name="l00134"></a>00134     <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0; i&lt;gdata-&gt;<a class="code" href="structGridData.html#a170b7b2a45022cc3d4aaee232844e50c">n_vert</a>; i++) {
<a name="l00135"></a>00135       <span class="keywordflow">if</span> (pid&gt;=0 &amp;&amp; gdata-&gt;<a class="code" href="structGridData.html#a5b4aaaf0ac71daeb341f45b50b6c744e">vertprop</a>[i]!=pid) <span class="keywordflow">continue</span>;
<a name="l00136"></a>00136       <span class="keywordflow">switch</span>(PetscAbsInt(init_mag)) {
<a name="l00137"></a>00137         <span class="keywordflow">case</span> 0:
<a name="l00138"></a>00138           <span class="comment">/* taken care of before switch */</span>
<a name="l00139"></a>00139         <span class="keywordflow">break</span>;
<a name="l00140"></a>00140         <span class="keywordflow">case</span> 1: <span class="comment">/* Mx=1 */</span>
<a name="l00141"></a>00141           ierr = VecSetValue(gdata-&gt;<a class="code" href="structGridData.html#aa8ed194b67f1446b9c299028c1ed0692">M</a>,<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*i+0,1.0*PetscSign(init_mag),INSERT_VALUES);CHKERRQ(ierr);
<a name="l00142"></a>00142           ierr = VecSetValue(gdata-&gt;<a class="code" href="structGridData.html#aa8ed194b67f1446b9c299028c1ed0692">M</a>,<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*i+1,0.0,INSERT_VALUES);CHKERRQ(ierr);
<a name="l00143"></a>00143           ierr = VecSetValue(gdata-&gt;<a class="code" href="structGridData.html#aa8ed194b67f1446b9c299028c1ed0692">M</a>,<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*i+2,0.0,INSERT_VALUES);CHKERRQ(ierr);
<a name="l00144"></a>00144         <span class="keywordflow">break</span>;
<a name="l00145"></a>00145         <span class="keywordflow">case</span> 2: <span class="comment">/* My=1 */</span>
<a name="l00146"></a>00146           ierr = VecSetValue(gdata-&gt;<a class="code" href="structGridData.html#aa8ed194b67f1446b9c299028c1ed0692">M</a>,<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*i+0,0.0,INSERT_VALUES);CHKERRQ(ierr);
<a name="l00147"></a>00147           ierr = VecSetValue(gdata-&gt;<a class="code" href="structGridData.html#aa8ed194b67f1446b9c299028c1ed0692">M</a>,<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*i+1,1.0*PetscSign(init_mag),INSERT_VALUES);CHKERRQ(ierr);
<a name="l00148"></a>00148           ierr = VecSetValue(gdata-&gt;<a class="code" href="structGridData.html#aa8ed194b67f1446b9c299028c1ed0692">M</a>,<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*i+2,0.0,INSERT_VALUES);CHKERRQ(ierr);
<a name="l00149"></a>00149         <span class="keywordflow">break</span>;
<a name="l00150"></a>00150         <span class="keywordflow">case</span> 3: <span class="comment">/* Mz=1 */</span>
<a name="l00151"></a>00151           ierr = VecSetValue(gdata-&gt;<a class="code" href="structGridData.html#aa8ed194b67f1446b9c299028c1ed0692">M</a>,<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*i+0,0.0,INSERT_VALUES);CHKERRQ(ierr);
<a name="l00152"></a>00152           ierr = VecSetValue(gdata-&gt;<a class="code" href="structGridData.html#aa8ed194b67f1446b9c299028c1ed0692">M</a>,<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*i+1,0.0,INSERT_VALUES);CHKERRQ(ierr);
<a name="l00153"></a>00153           ierr = VecSetValue(gdata-&gt;<a class="code" href="structGridData.html#aa8ed194b67f1446b9c299028c1ed0692">M</a>,<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*i+2,1.0*PetscSign(init_mag),INSERT_VALUES);CHKERRQ(ierr);
<a name="l00154"></a>00154         <span class="keywordflow">break</span>;
<a name="l00155"></a>00155         <span class="keywordflow">case</span> 4: <span class="comment">/* Mx=My=Mz=0.57735027 */</span>
<a name="l00156"></a>00156           ierr = VecSetValue(gdata-&gt;<a class="code" href="structGridData.html#aa8ed194b67f1446b9c299028c1ed0692">M</a>,<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*i+0,0.57735027*PetscSign(init_mag),INSERT_VALUES);CHKERRQ(ierr);
<a name="l00157"></a>00157           ierr = VecSetValue(gdata-&gt;<a class="code" href="structGridData.html#aa8ed194b67f1446b9c299028c1ed0692">M</a>,<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*i+1,0.57735027*PetscSign(init_mag),INSERT_VALUES);CHKERRQ(ierr);
<a name="l00158"></a>00158           ierr = VecSetValue(gdata-&gt;<a class="code" href="structGridData.html#aa8ed194b67f1446b9c299028c1ed0692">M</a>,<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*i+2,0.57735027*PetscSign(init_mag),INSERT_VALUES);CHKERRQ(ierr);
<a name="l00159"></a>00159         <span class="keywordflow">break</span>;
<a name="l00160"></a>00160         <span class="keywordflow">case</span> 5: <span class="comment">/* artificial flower state */</span>
<a name="l00161"></a>00161           ierr = VecSetValue(gdata-&gt;<a class="code" href="structGridData.html#aa8ed194b67f1446b9c299028c1ed0692">M</a>,<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*i+0,(gdata-&gt;<a class="code" href="structGridData.html#a1adbd5611aad877423d82c0ae9aae5ad">vertxyz</a>[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*i+0]-init_magparm)*PetscSign(init_mag),INSERT_VALUES);CHKERRQ(ierr);
<a name="l00162"></a>00162           ierr = VecSetValue(gdata-&gt;<a class="code" href="structGridData.html#aa8ed194b67f1446b9c299028c1ed0692">M</a>,<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*i+1,(gdata-&gt;<a class="code" href="structGridData.html#a1adbd5611aad877423d82c0ae9aae5ad">vertxyz</a>[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*i+1]-init_magparm)*PetscSign(init_mag),INSERT_VALUES);CHKERRQ(ierr);
<a name="l00163"></a>00163           ierr = VecSetValue(gdata-&gt;<a class="code" href="structGridData.html#aa8ed194b67f1446b9c299028c1ed0692">M</a>,<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*i+2,1.0*PetscSign(init_mag),INSERT_VALUES);CHKERRQ(ierr);
<a name="l00164"></a>00164         <span class="keywordflow">break</span>;
<a name="l00165"></a>00165         <span class="keywordflow">case</span> 6: <span class="comment">/* set magnetization in x-z plane to theta=init_magpar */</span>
<a name="l00166"></a>00166           ierr = VecSetValue(gdata-&gt;<a class="code" href="structGridData.html#aa8ed194b67f1446b9c299028c1ed0692">M</a>,<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*i+0,sin(init_magparm)*PetscSign(init_mag),INSERT_VALUES);CHKERRQ(ierr);
<a name="l00167"></a>00167           ierr = VecSetValue(gdata-&gt;<a class="code" href="structGridData.html#aa8ed194b67f1446b9c299028c1ed0692">M</a>,<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*i+1,0.0,INSERT_VALUES);CHKERRQ(ierr);
<a name="l00168"></a>00168           ierr = VecSetValue(gdata-&gt;<a class="code" href="structGridData.html#aa8ed194b67f1446b9c299028c1ed0692">M</a>,<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*i+2,cos(init_magparm)*PetscSign(init_mag),INSERT_VALUES);CHKERRQ(ierr);
<a name="l00169"></a>00169         <span class="keywordflow">break</span>;
<a name="l00170"></a>00170         <span class="keywordflow">case</span> 7: <span class="comment">/* vortex centered at (0,0) with radius R=init_magparm:</span>
<a name="l00171"></a>00171 <span class="comment">                 * if R&gt;0, then vortex is clockwise in xy plane.</span>
<a name="l00172"></a>00172 <span class="comment">                 * if R&lt;0, then vortex is counter-clockwise in xy plane.</span>
<a name="l00173"></a>00173 <span class="comment">                 * center of vortex points in -z direction.</span>
<a name="l00174"></a>00174 <span class="comment">                 */</span>
<a name="l00175"></a>00175           {
<a name="l00176"></a>00176             PetscReal x, y, r, R, A;
<a name="l00177"></a>00177             PetscReal modmx,modmy,modmz;
<a name="l00178"></a>00178 
<a name="l00179"></a>00179             x = gdata-&gt;<a class="code" href="structGridData.html#a1adbd5611aad877423d82c0ae9aae5ad">vertxyz</a>[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*i+0];
<a name="l00180"></a>00180             y = gdata-&gt;<a class="code" href="structGridData.html#a1adbd5611aad877423d82c0ae9aae5ad">vertxyz</a>[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*i+1];
<a name="l00181"></a>00181             r = sqrt(x*x + y*y);
<a name="l00182"></a>00182             R = init_magparm;
<a name="l00183"></a>00183 
<a name="l00184"></a>00184             A = 2.0*R*r/(R*R+r*r);
<a name="l00185"></a>00185             <span class="keywordflow">if</span> (r &lt;= fabs(R)) {
<a name="l00186"></a>00186               <span class="keywordflow">if</span> (r &gt; 1e-10) {
<a name="l00187"></a>00187                 modmx = A*y/r;
<a name="l00188"></a>00188                 modmy = -A*x/r;
<a name="l00189"></a>00189                 modmz = -sqrt(1.0-A*A);
<a name="l00190"></a>00190               } <span class="keywordflow">else</span> {
<a name="l00191"></a>00191                 modmx=0.0;
<a name="l00192"></a>00192                 modmy=0.0;
<a name="l00193"></a>00193                 modmz=-1.0;
<a name="l00194"></a>00194               }
<a name="l00195"></a>00195             } <span class="keywordflow">else</span> {
<a name="l00196"></a>00196               modmx=y/r;
<a name="l00197"></a>00197               modmy=-x/r;
<a name="l00198"></a>00198               modmz=0.0;
<a name="l00199"></a>00199             }
<a name="l00200"></a>00200             ierr = VecSetValue(gdata-&gt;<a class="code" href="structGridData.html#aa8ed194b67f1446b9c299028c1ed0692">M</a>,<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*i+0,modmx*PetscSign(init_mag),INSERT_VALUES);CHKERRQ(ierr);
<a name="l00201"></a>00201             ierr = VecSetValue(gdata-&gt;<a class="code" href="structGridData.html#aa8ed194b67f1446b9c299028c1ed0692">M</a>,<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*i+1,modmy*PetscSign(init_mag),INSERT_VALUES);CHKERRQ(ierr);
<a name="l00202"></a>00202             ierr = VecSetValue(gdata-&gt;<a class="code" href="structGridData.html#aa8ed194b67f1446b9c299028c1ed0692">M</a>,<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*i+2,modmz*PetscSign(init_mag),INSERT_VALUES);CHKERRQ(ierr);
<a name="l00203"></a>00203           }
<a name="l00204"></a>00204         <span class="keywordflow">break</span>;
<a name="l00205"></a>00205         <span class="keywordflow">case</span> 8: <span class="comment">/* random magnetization - inaccurate: not uniform on unit sphere! */</span>
<a name="l00206"></a>00206           PetscReal rval[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>],rnorm;
<a name="l00207"></a>00207 
<a name="l00208"></a>00208           PetscRandomGetValue(rctx,&amp;rval[0]);
<a name="l00209"></a>00209           PetscRandomGetValue(rctx,&amp;rval[1]);
<a name="l00210"></a>00210           PetscRandomGetValue(rctx,&amp;rval[2]);
<a name="l00211"></a>00211           rnorm=<a class="code" href="griddata_8h.html#ab47b959efcd0f78b2f58b0afbd532141">my_dnrm2</a>(<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>,rval,1);
<a name="l00212"></a>00212 
<a name="l00213"></a>00213           <span class="keywordflow">for</span> (<span class="keywordtype">int</span> k=0; k&lt;<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>; k++) {
<a name="l00214"></a>00214             ierr = VecSetValue(
<a name="l00215"></a>00215               gdata-&gt;<a class="code" href="structGridData.html#aa8ed194b67f1446b9c299028c1ed0692">M</a>,
<a name="l00216"></a>00216               ND*i+k,
<a name="l00217"></a>00217               (rval[k]/rnorm*2.0-1.0)*PetscSign(init_mag),
<a name="l00218"></a>00218               INSERT_VALUES
<a name="l00219"></a>00219             );CHKERRQ(ierr);
<a name="l00220"></a>00220           }
<a name="l00221"></a>00221         <span class="keywordflow">break</span>;
<a name="l00222"></a>00222         <span class="keywordflow">case</span> 9: <span class="comment">/* Bloch wall at x=+9.5 */</span>
<a name="l00223"></a>00223           <span class="keywordflow">if</span> (gdata-&gt;<a class="code" href="structGridData.html#a1adbd5611aad877423d82c0ae9aae5ad">vertxyz</a>[ND*i+0] &lt; init_magparm*0.95) {
<a name="l00224"></a>00224             ierr = VecSetValue(gdata-&gt;<a class="code" href="structGridData.html#aa8ed194b67f1446b9c299028c1ed0692">M</a>,ND*i+0, 0.0,INSERT_VALUES);CHKERRQ(ierr);
<a name="l00225"></a>00225             ierr = VecSetValue(gdata-&gt;<a class="code" href="structGridData.html#aa8ed194b67f1446b9c299028c1ed0692">M</a>,ND*i+1, 0.0,INSERT_VALUES);CHKERRQ(ierr);
<a name="l00226"></a>00226             ierr = VecSetValue(gdata-&gt;<a class="code" href="structGridData.html#aa8ed194b67f1446b9c299028c1ed0692">M</a>,ND*i+2,+1.0*PetscSign(init_mag),INSERT_VALUES);CHKERRQ(ierr);
<a name="l00227"></a>00227           }
<a name="l00228"></a>00228           <span class="keywordflow">else</span> <span class="keywordflow">if</span> (gdata-&gt;<a class="code" href="structGridData.html#a1adbd5611aad877423d82c0ae9aae5ad">vertxyz</a>[ND*i+0] &gt; init_magparm*1.05) {
<a name="l00229"></a>00229             ierr = VecSetValue(gdata-&gt;<a class="code" href="structGridData.html#aa8ed194b67f1446b9c299028c1ed0692">M</a>,ND*i+0, 0.0,INSERT_VALUES);CHKERRQ(ierr);
<a name="l00230"></a>00230             ierr = VecSetValue(gdata-&gt;<a class="code" href="structGridData.html#aa8ed194b67f1446b9c299028c1ed0692">M</a>,ND*i+1, 0.0,INSERT_VALUES);CHKERRQ(ierr);
<a name="l00231"></a>00231             ierr = VecSetValue(gdata-&gt;<a class="code" href="structGridData.html#aa8ed194b67f1446b9c299028c1ed0692">M</a>,ND*i+2,-1.0*PetscSign(init_mag),INSERT_VALUES);CHKERRQ(ierr);
<a name="l00232"></a>00232           }
<a name="l00233"></a>00233           <span class="keywordflow">else</span> {
<a name="l00234"></a>00234             ierr = VecSetValue(gdata-&gt;<a class="code" href="structGridData.html#aa8ed194b67f1446b9c299028c1ed0692">M</a>,ND*i+0, 0.1*PetscSign(init_mag),INSERT_VALUES);CHKERRQ(ierr);
<a name="l00235"></a>00235             ierr = VecSetValue(gdata-&gt;<a class="code" href="structGridData.html#aa8ed194b67f1446b9c299028c1ed0692">M</a>,ND*i+1,-0.9*PetscSign(init_mag),INSERT_VALUES);CHKERRQ(ierr);
<a name="l00236"></a>00236             ierr = VecSetValue(gdata-&gt;<a class="code" href="structGridData.html#aa8ed194b67f1446b9c299028c1ed0692">M</a>,ND*i+2, 0.1*PetscSign(init_mag),INSERT_VALUES);CHKERRQ(ierr);
<a name="l00237"></a>00237           }
<a name="l00238"></a>00238         <span class="keywordflow">break</span>;
<a name="l00239"></a>00239         <span class="keywordflow">case</span> 10: <span class="comment">/* magnetization parallel to anisotropy axes */</span>
<a name="l00240"></a>00240           <span class="keywordflow">for</span> (<span class="keywordtype">int</span> k=0; k&lt;ND; k++) {
<a name="l00241"></a>00241             ierr = VecSetValue(
<a name="l00242"></a>00242               gdata-&gt;<a class="code" href="structGridData.html#aa8ed194b67f1446b9c299028c1ed0692">M</a>,
<a name="l00243"></a>00243               ND*i+k,
<a name="l00244"></a>00244               gdata-&gt;<a class="code" href="structGridData.html#a3df9afbdf3e91a79a68b52cae80020f4">propdat</a>[<a class="code" href="griddata_8h.html#ab04c88bedc6b2be8ddfe7aa8d3e93f06">NP</a>*gdata-&gt;<a class="code" href="structGridData.html#a5b4aaaf0ac71daeb341f45b50b6c744e">vertprop</a>[i]+6+k]*PetscSign(init_mag),
<a name="l00245"></a>00245               INSERT_VALUES
<a name="l00246"></a>00246             );CHKERRQ(ierr);
<a name="l00247"></a>00247           }
<a name="l00248"></a>00248         <span class="keywordflow">break</span>;
<a name="l00249"></a>00249         <span class="keywordflow">case</span> 11: <span class="comment">/* set magnetization in x-y plane to alpha=init_magparm */</span>
<a name="l00250"></a>00250           ierr = VecSetValue(gdata-&gt;<a class="code" href="structGridData.html#aa8ed194b67f1446b9c299028c1ed0692">M</a>,ND*i+0,cos(init_magparm*PETSC_PI/180.0)*PetscSign(init_mag),INSERT_VALUES);CHKERRQ(ierr);
<a name="l00251"></a>00251           ierr = VecSetValue(gdata-&gt;<a class="code" href="structGridData.html#aa8ed194b67f1446b9c299028c1ed0692">M</a>,ND*i+1,sin(init_magparm*PETSC_PI/180.0)*PetscSign(init_mag),INSERT_VALUES);CHKERRQ(ierr);
<a name="l00252"></a>00252           ierr = VecSetValue(gdata-&gt;<a class="code" href="structGridData.html#aa8ed194b67f1446b9c299028c1ed0692">M</a>,ND*i+2,0.0,INSERT_VALUES);CHKERRQ(ierr);
<a name="l00253"></a>00253         <span class="keywordflow">break</span>;
<a name="l00254"></a>00254         <span class="keywordflow">case</span> 12: <span class="comment">/* Head-to-head transverse wall at x=init_magparm */</span>
<a name="l00255"></a>00255           <span class="keywordflow">if</span> (gdata-&gt;<a class="code" href="structGridData.html#a1adbd5611aad877423d82c0ae9aae5ad">vertxyz</a>[ND*i+0] &lt; init_magparm*0.95) {
<a name="l00256"></a>00256             ierr=VecSetValue(gdata-&gt;<a class="code" href="structGridData.html#aa8ed194b67f1446b9c299028c1ed0692">M</a>,ND*i+0, 1.0*PetscSign(init_mag),INSERT_VALUES);CHKERRQ(ierr);
<a name="l00257"></a>00257             ierr=VecSetValue(gdata-&gt;<a class="code" href="structGridData.html#aa8ed194b67f1446b9c299028c1ed0692">M</a>,ND*i+1, 0.0,INSERT_VALUES);CHKERRQ(ierr);
<a name="l00258"></a>00258             ierr=VecSetValue(gdata-&gt;<a class="code" href="structGridData.html#aa8ed194b67f1446b9c299028c1ed0692">M</a>,ND*i+2, 0.0,INSERT_VALUES);CHKERRQ(ierr);
<a name="l00259"></a>00259           }
<a name="l00260"></a>00260           <span class="keywordflow">else</span> <span class="keywordflow">if</span> (gdata-&gt;<a class="code" href="structGridData.html#a1adbd5611aad877423d82c0ae9aae5ad">vertxyz</a>[ND*i+0] &gt; init_magparm*1.05) {
<a name="l00261"></a>00261             ierr=VecSetValue(gdata-&gt;<a class="code" href="structGridData.html#aa8ed194b67f1446b9c299028c1ed0692">M</a>,ND*i+0,-1.0*PetscSign(init_mag),INSERT_VALUES);CHKERRQ(ierr);
<a name="l00262"></a>00262             ierr=VecSetValue(gdata-&gt;<a class="code" href="structGridData.html#aa8ed194b67f1446b9c299028c1ed0692">M</a>,ND*i+1, 0.0,INSERT_VALUES);CHKERRQ(ierr);
<a name="l00263"></a>00263             ierr=VecSetValue(gdata-&gt;<a class="code" href="structGridData.html#aa8ed194b67f1446b9c299028c1ed0692">M</a>,ND*i+2, 0.0,INSERT_VALUES);CHKERRQ(ierr);
<a name="l00264"></a>00264           }
<a name="l00265"></a>00265           <span class="keywordflow">else</span> {
<a name="l00266"></a>00266             ierr=VecSetValue(gdata-&gt;<a class="code" href="structGridData.html#aa8ed194b67f1446b9c299028c1ed0692">M</a>,ND*i+0, 0.0,INSERT_VALUES);CHKERRQ(ierr);
<a name="l00267"></a>00267             ierr=VecSetValue(gdata-&gt;<a class="code" href="structGridData.html#aa8ed194b67f1446b9c299028c1ed0692">M</a>,ND*i+1, 1.0*PetscSign(init_mag),INSERT_VALUES);CHKERRQ(ierr);
<a name="l00268"></a>00268             ierr=VecSetValue(gdata-&gt;<a class="code" href="structGridData.html#aa8ed194b67f1446b9c299028c1ed0692">M</a>,ND*i+2, 0.0,INSERT_VALUES);CHKERRQ(ierr);
<a name="l00269"></a>00269           }
<a name="l00270"></a>00270         <span class="keywordflow">break</span>;
<a name="l00271"></a>00271         <span class="keywordflow">case</span> 13: <span class="comment">/* Head-to-head vortex wall at (0,0) with radius R=init_magparm:</span>
<a name="l00272"></a>00272 <span class="comment">                  * if R&gt;0, then vortex is clockwise in xy plane.</span>
<a name="l00273"></a>00273 <span class="comment">                  * if R&lt;0, then vortex is counter-clockwise in xy plane.</span>
<a name="l00274"></a>00274 <span class="comment">                  * center of vortex points in -z direction.</span>
<a name="l00275"></a>00275 <span class="comment">                  */</span>
<a name="l00276"></a>00276           {
<a name="l00277"></a>00277             PetscReal x, y, r, R, A;
<a name="l00278"></a>00278             PetscReal modmx,modmy,modmz;
<a name="l00279"></a>00279 
<a name="l00280"></a>00280             x = gdata-&gt;<a class="code" href="structGridData.html#a1adbd5611aad877423d82c0ae9aae5ad">vertxyz</a>[ND*i+0];
<a name="l00281"></a>00281             y = gdata-&gt;<a class="code" href="structGridData.html#a1adbd5611aad877423d82c0ae9aae5ad">vertxyz</a>[ND*i+1];
<a name="l00282"></a>00282             r = sqrt(x*x + y*y);
<a name="l00283"></a>00283             R = init_magparm;
<a name="l00284"></a>00284 
<a name="l00285"></a>00285             A = 2.0*R*r/(R*R+r*r);
<a name="l00286"></a>00286             <span class="keywordflow">if</span> (r &lt;= fabs(R)) {
<a name="l00287"></a>00287               <span class="keywordflow">if</span> (r &gt; 1e-10) {
<a name="l00288"></a>00288                 modmx = A*y/r;
<a name="l00289"></a>00289                 modmy = -A*x/r;
<a name="l00290"></a>00290                 modmz = -sqrt(1.0-A*A);
<a name="l00291"></a>00291               } <span class="keywordflow">else</span> {
<a name="l00292"></a>00292                 modmx = 0.0;
<a name="l00293"></a>00293                 modmy = 0.0;
<a name="l00294"></a>00294                 modmz = -1.0;
<a name="l00295"></a>00295               }
<a name="l00296"></a>00296             } <span class="keywordflow">else</span> {
<a name="l00297"></a>00297               modmx = (x&lt;0.0 ? +1.0 : -1.0);
<a name="l00298"></a>00298               modmy = 0.0;
<a name="l00299"></a>00299               modmz = 0.0;
<a name="l00300"></a>00300             }
<a name="l00301"></a>00301             ierr = VecSetValue(gdata-&gt;<a class="code" href="structGridData.html#aa8ed194b67f1446b9c299028c1ed0692">M</a>,ND*i+0,modmx*PetscSign(init_mag),INSERT_VALUES);CHKERRQ(ierr);
<a name="l00302"></a>00302             ierr = VecSetValue(gdata-&gt;<a class="code" href="structGridData.html#aa8ed194b67f1446b9c299028c1ed0692">M</a>,ND*i+1,modmy*PetscSign(init_mag),INSERT_VALUES);CHKERRQ(ierr);
<a name="l00303"></a>00303             ierr = VecSetValue(gdata-&gt;<a class="code" href="structGridData.html#aa8ed194b67f1446b9c299028c1ed0692">M</a>,ND*i+2,modmz*PetscSign(init_mag),INSERT_VALUES);CHKERRQ(ierr);
<a name="l00304"></a>00304           }
<a name="l00305"></a>00305         <span class="keywordflow">break</span>;
<a name="l00306"></a>00306         <span class="keywordflow">case</span> 14:
<a name="l00307"></a>00307           <span class="comment">/* taken care of before switch */</span>
<a name="l00308"></a>00308         <span class="keywordflow">break</span>;
<a name="l00309"></a>00309         <span class="keywordflow">default</span>:
<a name="l00310"></a>00310           SETERRQ1(PETSC_ERR_ARG_OUTOFRANGE,<span class="stringliteral">&quot;init_mag value %i is illegal!\n&quot;</span>,PetscAbsInt(init_mag));
<a name="l00311"></a>00311         <span class="keywordflow">break</span>;
<a name="l00312"></a>00312       }
<a name="l00313"></a>00313     }
<a name="l00314"></a>00314 
<a name="l00315"></a>00315     ierr = PetscRandomDestroy(rctx);CHKERRQ(ierr);
<a name="l00316"></a>00316     ierr = PetscFree(gdata-&gt;<a class="code" href="structGridData.html#a5b4aaaf0ac71daeb341f45b50b6c744e">vertprop</a>);CHKERRQ(ierr);
<a name="l00317"></a>00317     gdata-&gt;<a class="code" href="structGridData.html#a5b4aaaf0ac71daeb341f45b50b6c744e">vertprop</a>=PETSC_NULL;
<a name="l00318"></a>00318   }
<a name="l00319"></a>00319 
<a name="l00320"></a>00320   ierr = VecAssemblyBegin(gdata-&gt;<a class="code" href="structGridData.html#aa8ed194b67f1446b9c299028c1ed0692">M</a>);CHKERRQ(ierr);
<a name="l00321"></a>00321   ierr = VecAssemblyEnd(gdata-&gt;<a class="code" href="structGridData.html#aa8ed194b67f1446b9c299028c1ed0692">M</a>);CHKERRQ(ierr);
<a name="l00322"></a>00322 
<a name="l00323"></a>00323   <span class="comment">/* rescale magnetization (required by init_mag==5) */</span>
<a name="l00324"></a>00324   <a class="code" href="renormvec_8c.html#abba3d002260d6e3e062ac69a80300aa4">RenormVec</a>(gdata-&gt;<a class="code" href="structGridData.html#aa8ed194b67f1446b9c299028c1ed0692">M</a>,1.0,0.0,<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>);
<a name="l00325"></a>00325 
<a name="l00326"></a>00326   <a class="code" href="griddata_8h.html#a8491466d8534a33d7163f5ea747e8210">MagparFunctionLogReturn</a>(0);
<a name="l00327"></a>00327 }
</pre></div></div>
  <hr>
  <address>
    magpar - Parallel Finite Element Micromagnetics Package<br>
    Copyright (C) 2002-2010 Werner Scholz
  </address>
  </body>
</html>

